---------------------------------------------------
---------------------------------------------------
--  Easy 1 Processor Architecture				 --
--  University of Puerto Rico					 --
--  Mayaguez Campus								 --
--	Department of Computer Engineering			 --
-- 												 --
--	Copyright (c) 2003							 --
--	All rigths reserved.						 --
--										   		 --
--	Prof. Bienvenido Vlez						 --
--	Abdiel Avils								 --
--	Rafael S. Garca							 --
--	Nesmary Hernndez 							 --
-- 	Carlos Prez								 --
---------------------------------------------------
---------------------------------------------------
-- 	[easy1_add.vhd]
--	Easy 1 Adder
--	This module describes the Easy 1 Adder.
--	The Easy 1 Adder receives two operands in two's
--	complement logic and adds them. The result and
--	carry out are outputs.
---------------------------------------------------	
---------------------------------------------------
--	Libraries declarations
library ieee;
use ieee.std_logic_1164.all;   
use easy1_package.all;
--
---------------------------------------------------
--	Entity declaration
--	@a        	- operand from the A Bus
--	@b        	- operand from the Accumulator
--	@sum		- result
--	@cout		- carry out
--					 
entity easy1_add is
	
	port (
		a    : in  std_logic_vector(15 downto 0):=X"0000";
		b    : in  std_logic_vector(15 downto 0):=X"0000";
		sum  : out std_logic_vector(15 downto 0):=X"0000";
		cout : out std_logic:='0');
	
end easy1_add;
--
----------------------------------------------------
--	Architecture declaration
--
architecture arq of easy1_add is

begin
	--	Sensitivity List :
	--		This list holds the signals that modify and 
	--		control the register data.	 
	--
	--	Variables :
	--		c		- ripple carry

	process(a,b)
		variable c : std_logic:='0'; 
	begin  			
		-- Cascaded adder
		for i in 0 to 15 loop
			sum(i) <= a(i) xor b(i) xor c;
			c := (a(i) and b(i))or (a(i) and c)or (b(i) and c);
		end loop;
		cout<=c; 
	end process;
end arq;
----------------------------------------------------
----------------------------------------------------