---------------------------------------------------
---------------------------------------------------
--  Easy 1 Processor Architecture				 --
--  University of Puerto Rico					 --
--  Mayaguez Campus								 --
--	Department of Computer Engineering			 --
-- 												 --
--	Copyright (c) 2003							 --
--	All rigths reserved.						 --
--										   		 --
--	Prof. Bienvenido Vlez						 --
--	Abdiel Avils								 --
--	Rafael S. Garca							 --
--	Nesmary Hernndez 							 --
-- 	Carlos Prez								 --
---------------------------------------------------
---------------------------------------------------
-- 	[easy1_reg_st.vhd]
--	Easy 1 State Register
--	Behavioral description of a 4 bit latch
---------------------------------------------------	
---------------------------------------------------
--	Libraries declarations
library ieee ;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all; 
use easy1_package.all;
--
---------------------------------------------------
--	Entity declaration
--	@i      	- data input
--	@load		- load signal (clock)
--	@clear		- clear signal 
--	@o			- register output
--
entity easy1_reg_st is
	
	port(	
		i		:	in std_logic_vector(3 downto 0):=X"0";
		load	:	in std_logic:='0';
		clear	:	in std_logic:='0';
		o		:	out std_logic_vector(3 downto 0):=X"0"
		);
end easy1_reg_st;
--
----------------------------------------------------
--	Architecture declaration
--
architecture behv of easy1_reg_st is
	
begin
	--	Sensitivity List :
	--		This list holds the signals that modify and 
	--		control the register data. This register is
	--		sensitive to the load and the clear signal.
	--		The load signal is the same as the clock
	--		signal in the port mapping.
	process(load, clear)
	begin
		--	If a clear signal is received assign low to the
		--	output.
		if clear = '1' then
			o <= X"0" after DELAY_1_LEVEL;
		--	Load the input
		elsif ( load'event) then
			o <= i after DELAY_1_LEVEL;										 
		end if;
		
	end process;
	
end behv;
----------------------------------------------------
----------------------------------------------------