---------------------------------------------------
---------------------------------------------------
--  Easy 1 Processor Architecture				 --
--  University of Puerto Rico					 --
--  Mayaguez Campus								 --
--	Department of Computer Engineering			 --
-- 												 --
--	Copyright (c) 2003							 --
--	All rigths reserved.						 --
--										   		 --
--	Prof. Bienvenido Vlez						 --
--	Abdiel Avils								 --
--	Rafael S. Garca							 --
--	Nesmary Hernndez 							 --
-- 	Carlos Prez								 --
---------------------------------------------------
---------------------------------------------------
-- 	[easy1_SXTL.vhd]
--	Easy 1 Sign Extend Logic Module
--	This module extends or not the sign of the value
--	X on the easy 1 instruction. It is composed of 
--	a multiplexer and some conected to the outputs
--	of it.
---------------------------------------------------	
---------------------------------------------------
--	Libraries declarations
library ieee;
use ieee.std_logic_1164.all; 
use easy1_package.all;
--
---------------------------------------------------
--	Entity declaration
--	@sxt_sel	- signal to select the mux output
--	@input_SXT 	- input data
--	@output_SXT	- output data with/without sign extension
--									
entity easy1_SXTL is
	
	port(
		sxt_sel	: in std_logic_vector(1 downto 0):="00";
		input_SXT	: in std_logic_vector(15 downto 0):=X"0000";
		output_SXT	: out std_logic_vector(15 downto 0):=X"0000"
		);
	
end easy1_SXTL;
--
----------------------------------------------------
--	Architecture declaration	 
--
architecture arq of easy1_SXTL is
	
begin		 
	--	Sensitivity List :
	--		This list holds the signals that modify and 
	--		control the register data. The multiplexer
	--		is sensitive to the selection signal and
	--		the input data.
	process(sxt_sel,input_SXT)
	begin				  
		-- The multiplexer is described as a "case"	statement
		case sxt_sel is	
			--  The data input register contains an instruccion
			--	with a two's complement value in X. The sign of
			--	this value must be extended.
			when "00" =>
			case input_SXT(9) is
				--	If negative, extend bits 15 to 10 with bit 9
				-- 	value.
				when '1' =>
				output_SXT <= "111111" & input_SXT(9 downto 0);	 
				--	If positive, extend bits 15 to 10 with bit 9
				-- 	value.
				when '0' =>
				output_SXT <= "000000" & input_SXT(9 downto 0);
				when others => null;
			end case;	  
			--  The data input register contains an instruccion
			--	with an address value in X. This is an unsigned
			--	value.
			when "01" =>
			output_SXT <= "000000" & input_SXT(9 downto 0) after DELAY_1_LEVEL;
			--  The data input register does not contains an
			--	instruction. The value must be left intact.
			when "10" =>
			output_SXT <= input_SXT after DELAY_1_LEVEL;
			when others => null;
		end case;
	end process;
	
end arq;
---------------------------------------------------	
---------------------------------------------------